"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const fs_extra_1 = require("fs-extra");
const rfs = require("rotating-file-stream");
const path_1 = require("path");
class FileWriter {
    constructor(path, interval) {
        if (interval) {
            let dir = path_1.dirname(path);
            let file = path_1.basename(path);
            fs_extra_1.ensureDirSync(dir);
            this._stream = rfs(file, {
                interval,
                path: dir,
            });
        }
        else {
            let dir = path_1.dirname(path);
            fs_extra_1.ensureDirSync(dir);
            this._stream = fs_extra_1.createWriteStream(path, {
                flags: 'a',
            });
        }
    }
    _message(type, msg) {
        this._stream.write(`\n${type}: ` + msg);
    }
    log(msg) {
        this._message('log', msg);
    }
    error(msg) {
        this._message('err', msg);
    }
}
exports.FileWriter = FileWriter;
exports.default = FileWriter;
